package com.accmee.quiz.mobile;


import com.accmee.quiz.application.DBConnectionFactory;

import com.sun.util.logging.Level;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;

import oracle.adfmf.util.Utility;
import oracle.adfmf.util.logging.Trace;


public class QuizDao
{
    private DBConnectionFactory dbHelper;

    public QuizDao()
    {
        dbHelper = new DBConnectionFactory();
    }

    public void addWord(String word, String interpretedWord)
    {
        try
        {
            Trace.log(Utility.ApplicationLogger, Level.INFO, QuizDao.class, "addWord", "Coming Inside addWord Method");
            Connection conn = dbHelper.getConnection();

            String insertSQL = "Insert into WordCouples (_id, word, interpretedword) values (null,?,?)";

            PreparedStatement pStmt = conn.prepareStatement(insertSQL);

            pStmt.setString(1, word);
            pStmt.setString(2, interpretedWord);
            pStmt.execute();

            Trace.log(Utility.ApplicationLogger, Level.INFO, QuizDao.class, "addWord",
                      "word: " + word + " interpretedword: " + interpretedWord + " is existing anymore ");
        }
        catch (Exception e)
        {
            System.err.println(e.getMessage());
        }
        finally
        {
        }
    }

    public com.accmee.quiz.mobile.QuizDataObject getRandomQuizDataObject(String translateWay)
    {
        com.accmee.quiz.mobile.QuizDataObject quizDataObject = null;
        try
        {
            Trace.log(Utility.ApplicationLogger, Level.INFO, QuizDao.class, "getRandomQuizDataObject", "Coming Inside getRandomQuizDataObject Method");

            Connection conn = dbHelper.getConnection();
            String countSQL = "select count(_id) as cnt from wordcouples";
            PreparedStatement pStmt = conn.prepareStatement(countSQL);
            ResultSet rs = pStmt.executeQuery();

            int cnt = 0;
            if (rs.next())
            {
                cnt = rs.getInt("cnt");
            }

            int id = RandomNumber.GetRandomNumber(1, cnt);
            quizDataObject = getQuizDataObjectById(id, translateWay);

            int index;
            index = RandomNumber.GetRandomNumber(0, 2);

            //set correct interpreted word into randomized indexed option
            quizDataObject.setOption(index, quizDataObject.getInterpretedWord());

            int idForWrongOption = 0;
            int idForWrongOption2 = 0;

            // find random db id for option interpreted words
            do
            {
                idForWrongOption = RandomNumber.GetRandomNumber(1, cnt);
            }
            while (id == idForWrongOption);

            do
            {
                idForWrongOption2 = RandomNumber.GetRandomNumber(1, cnt);
            }
            while (idForWrongOption2 == id || idForWrongOption2 == idForWrongOption);
            // find random db id for option interpreted words

            do
            {
                index = RandomNumber.GetRandomNumber(0, 2);
            }
            while (quizDataObject.isOptionFilled((index)));
            quizDataObject.setOption(index, getQuizDataObjectById(idForWrongOption, translateWay).getInterpretedWord());

            do
            {
                index = RandomNumber.GetRandomNumber(0, 2);
            }
            while (quizDataObject.isOptionFilled(index));

            quizDataObject.setOption(index, getQuizDataObjectById(idForWrongOption2, translateWay).getInterpretedWord());
        }
        catch (Exception e)
        {
            System.err.println(e.getMessage());
        }
        finally
        {
        }
        return quizDataObject;
    }

    public com.accmee.quiz.mobile.QuizDataObject getQuizDataObjectById(int id, String translateWay)
    {
        QuizDataObject quizDataObject = null;
        try
        {
            quizDataObject = new QuizDataObject();
            String word = null;
            String interpretedWord = null;

            Connection conn = dbHelper.getConnection();
            String sqlQuery = "select * from WordCouples where _id=?";
            PreparedStatement pStmt = conn.prepareStatement(sqlQuery);
            pStmt.setInt(1, id);
            ResultSet rs = pStmt.executeQuery();
            if (rs.next())
            {
                if (QuizMBean.EN_TR.equals(translateWay))
                {
                    word = rs.getString("word");
                    interpretedWord = rs.getString("interpretedword");
                } else
                {
                    interpretedWord = rs.getString("word");
                    word = rs.getString("interpretedword");
                }
            }

            quizDataObject.setId(id);
            quizDataObject.setWord(word);
            quizDataObject.setInterpretedWord(interpretedWord);

            Trace.log(Utility.ApplicationLogger, Level.INFO, QuizDao.class, "getQuizDataObjectById", quizDataObject.toString() + "object will be returned");
        }
        catch (Exception e)
        {
            System.err.println(e.getMessage());
        }
        finally
        {
        }
        return quizDataObject;
    }
}
