package com.accmee.quiz.mobile;

import javax.el.ValueExpression;

import oracle.adfmf.amx.event.ActionEvent;
import oracle.adfmf.amx.event.ValueChangeEvent;
import oracle.adfmf.framework.api.AdfmfContainerUtilities;
import oracle.adfmf.framework.api.AdfmfJavaUtilities;
import oracle.adfmf.java.beans.PropertyChangeListener;
import oracle.adfmf.java.beans.PropertyChangeSupport;
import oracle.adfmf.javax.faces.model.SelectItem;


public class QuizMBean
{
    QuizDao dao = null;

    //    private String word;
    private String option1;
    private String option2;
    private String option3;
    private String result;
    private QuizDataObject object;
    private String word;
    private SelectItem[] options;
    private boolean optionDisabled;

    private String selectedWord;

    public final static String TR_EN = "tr-en";
    public final static String EN_TR = "en-tr";

    private transient PropertyChangeSupport propertyChangeSupport = new PropertyChangeSupport(this);


    public QuizMBean()
    {
        super();
        dao = new QuizDao();
        init();
    }

    public void init()
    {
        initializeNewQuestion();
    }

    public void addPropertyChangeListener(PropertyChangeListener l)
    {
        propertyChangeSupport.addPropertyChangeListener(l);
    }

    public void removePropertyChangeListener(PropertyChangeListener l)
    {
        propertyChangeSupport.removePropertyChangeListener(l);
    }

    public void setResult(String result)
    {
        String oldResult = this.result;
        this.result = result;
        propertyChangeSupport.firePropertyChange("result", oldResult, result);
    }

    public String getResult()
    {
        return result;
    }

    public void setObject(QuizDataObject object)
    {
        QuizDataObject oldObject = this.object;
        this.object = object;
        propertyChangeSupport.firePropertyChange("object", oldObject, object);
    }

    public QuizDataObject getObject()
    {
        return object;
    }

    public void setOption1(String option1)
    {
        String oldOption1 = this.option1;
        this.option1 = option1;
        propertyChangeSupport.firePropertyChange("option1", oldOption1, option1);
    }

    public String getOption1()
    {
        return option1;
    }

    public void setOption2(String option2)
    {
        String oldOption2 = this.option2;
        this.option2 = option2;
        propertyChangeSupport.firePropertyChange("option2", oldOption2, option2);
    }

    public String getOption2()
    {
        return option2;
    }

    public void setOption3(String option3)
    {
        String oldOption3 = this.option3;
        this.option3 = option3;
        propertyChangeSupport.firePropertyChange("option3", oldOption3, option3);
    }

    public String getOption3()
    {
        return option3;
    }

    public void optionSelected(ValueChangeEvent valueChangeEvent)
    {
        if (valueChangeEvent != null && valueChangeEvent.getNewValue() != null)
        {
            setOptionDisabled(true);
            if (getObject().isRight((String)valueChangeEvent.getNewValue()))
                setResult("Doru");
            else
                setResult("Yanl");
        }
    }

    public void optionSelected(ActionEvent actionEvent)
    {
        setOptionDisabled(true);
        if (getObject().isRight(getSelectedWord()))
            setResult("Doru");
        else
            setResult("Yanl");
    }

    private void initializeNewQuestion()
    {
        setObject(dao.getRandomQuizDataObject(getTranslateWay()));
        setWord(getObject().getWord());
        //initSelectItems();
        setResult(null);
        setOptionDisabled(false);
        initBeanOptions();
    }

    public void setOptions(SelectItem[] options)
    {
        SelectItem[] oldOptions = this.options;
        this.options = options;
        propertyChangeSupport.firePropertyChange("options", oldOptions, options);
    }

    public SelectItem[] getOptions()
    {
        return options;
    }

    public void setPropertyChangeSupport(PropertyChangeSupport propertyChangeSupport)
    {
        PropertyChangeSupport oldPropertyChangeSupport = this.propertyChangeSupport;
        this.propertyChangeSupport = propertyChangeSupport;
        propertyChangeSupport.firePropertyChange("propertyChangeSupport", oldPropertyChangeSupport, propertyChangeSupport);
    }

    public PropertyChangeSupport getPropertyChangeSupport()
    {
        return propertyChangeSupport;
    }

    //    private void initSelectItems()
    //    {
    //        SelectItem[] items = new SelectItem[3];
    //        SelectItem item = null;
    //        for (int i = 0; i < object.getOptions().length; i++)
    //        {
    //            item = new SelectItem(object.getOption(i), object.getOption(i));
    //            items[i] = item;
    //        }
    //        setOptions(items);
    //    }

    public void reload() throws InterruptedException
    {
        //Thread.sleep(2000);
        init();
    }

    public void setOptionDisabled(boolean optionDisabled)
    {
        boolean oldOptionDisabled = this.optionDisabled;
        this.optionDisabled = optionDisabled;
        propertyChangeSupport.firePropertyChange("optionDisabled", oldOptionDisabled, optionDisabled);
    }

    public boolean isOptionDisabled()
    {
        return optionDisabled;
    }

    public void setSelectedWord(String selectedWord)
    {
        String oldSelectedWord = this.selectedWord;
        this.selectedWord = selectedWord;
        propertyChangeSupport.firePropertyChange("selectedWord", oldSelectedWord, selectedWord);
    }

    public String getSelectedWord()
    {
        return selectedWord;
    }

    private void initBeanOptions()
    {
        setOption1(getObject().getOption(0));
        setOption2(getObject().getOption(1));
        setOption3(getObject().getOption(2));
    }

    public void showIFrame(ActionEvent actionEvent)
    {
        // Add event code here...
    }

    public String getTranslateWay()
    {
        String tWay = null;
        ValueExpression ve = AdfmfJavaUtilities.getValueExpression("#{pageFlowScope.quizLangBean.translateWay}", String.class);
        tWay = ((String)ve.getValue(AdfmfJavaUtilities.getAdfELContext()));
        return tWay;
    }

    public void navigateBack(ActionEvent actionEvent)
    {
        AdfmfContainerUtilities.invokeContainerJavaScriptFunction(AdfmfJavaUtilities.getFeatureName(), "adf.mf.api.amx.doNavigation", new Object[] { "back" });
    }

    public void navigateNext(ActionEvent actionEvent)
    {
        AdfmfContainerUtilities.invokeContainerJavaScriptFunction(AdfmfJavaUtilities.getFeatureName(), "adf.mf.api.amx.doNavigation", new Object[] { "wait" });
    }

    public String next() throws InterruptedException
    {
        reload();
        return null;
    }

    public void setWord(String word) {
        String oldWord = this.word;
        this.word = word;
        propertyChangeSupport.firePropertyChange("word", oldWord, word);
    }

    public String getWord() {
        return word;
    }
}
