package com.accmee.quiz.mobile;

import oracle.adfmf.amx.event.ActionEvent;
import oracle.adfmf.java.beans.PropertyChangeListener;
import oracle.adfmf.java.beans.PropertyChangeSupport;

public class WordDefinitionMBean
{
    private String word;
    private String interpretedWord;
    private QuizDao dao;
    
    private transient PropertyChangeSupport propertyChangeSupport = new PropertyChangeSupport(this);

    public WordDefinitionMBean()
    {
        super();
        dao=new QuizDao();
    }

    public void addToDB(ActionEvent actionEvent)
    {
        dao.addWord(getWord(), getInterpretedWord());
        setWord(null);
        setInterpretedWord(null);
    }

    public void setWord(String word)
    {
        String oldWord = this.word;
        this.word = word;
        propertyChangeSupport.firePropertyChange("word", oldWord, word);
    }

    public void addPropertyChangeListener(PropertyChangeListener l)
    {
        propertyChangeSupport.addPropertyChangeListener(l);
    }

    public void removePropertyChangeListener(PropertyChangeListener l)
    {
        propertyChangeSupport.removePropertyChangeListener(l);
    }

    public String getWord()
    {
        return word;
    }

    public void setInterpretedWord(String interpretedWord)
    {
        String oldInterpretedWord = this.interpretedWord;
        this.interpretedWord = interpretedWord;
        propertyChangeSupport.firePropertyChange("interpretedWord", oldInterpretedWord, interpretedWord);
    }

    public String getInterpretedWord()
    {
        return interpretedWord;
    }
}
