package com.acme.structure.util;


import java.math.BigDecimal;

import java.util.Random;


/**
 * <p>Title: MathUtility.java </p>
 * <p>Description: </p>
 *
 * @author MustafaY
 * @version 1.0, , Jul 24, 2008
 * @see
 * @since
 */
public class MathUtility
{
    public static double roundToNearest(double number)
    {
        return roundToNearestWithScale(number, 2);
    }

    /*
	 * BigDecimal constructor with double parameter return unpredictable results
	 * so conversion to string is used
	 */

    public static double roundToNearestWithScale(double number, int scale)
    {
        //BigDecimal temp = new BigDecimal(number);
        BigDecimal temp = new BigDecimal(Double.toString(number));
        temp = temp.setScale(scale, BigDecimal.ROUND_HALF_UP);

        return temp.doubleValue();
    }

    public static double roundUp(double number)
    {
        return roundUpWithScale(number, 0);
    }

    public static double roundUpWithScale(double number, int scale)
    {
        //BigDecimal temp = new BigDecimal(number);
        BigDecimal temp = new BigDecimal(Double.toString(number));
        temp = temp.setScale(scale, BigDecimal.ROUND_CEILING);

        return temp.doubleValue();
    }

    public static double roundDown(double number)
    {
        return roundDownWithScale(number, 0);
    }

    public static double roundDownWithScale(double number, int scale)
    {
        //BigDecimal temp = new BigDecimal(number);
        BigDecimal temp = new BigDecimal(Double.toString(number));
        temp = temp.setScale(scale, BigDecimal.ROUND_FLOOR);

        return temp.doubleValue();
    }

    public static double getDecimalPart(double number)
    {
        double roundedValue = roundDown(number);

        return number - roundedValue;
    }

    public static int getRandomNumber(int range)
    {
        Random randomGenerator = new Random();
        return randomGenerator.nextInt(range);
    }
}
